// 构建
var _ = require('lodash');
var databaseHelper = require("../tools/databaseHelper")
var javaBuilder = require('./java');

const build = async (p_id, env_id, branch, version) => {
    //获取项目基本信息
    var projectObj = await databaseHelper.findOne('project', p_id, 'p_id');
    console.log(JSON.stringify(projectObj));
    // 获取构建类型源数据
    var type_id = projectObj.type;
    var typeObj = await databaseHelper.findOne('meta_data', type_id, 'type_id');
    console.log(JSON.stringify(typeObj));
    // 获取环境源数据  
    var envObj = await databaseHelper.findOne('env', env_id, 'env_id');
    console.log(JSON.stringify(envObj));

    // 获取配置数据
    var configList = await databaseHelper.listDbByJson({
        p_id,
        env_id,
    }, 'project_config', "*");
    console.log(JSON.stringify(configList));

    // check 检查同一个项目 同一个环境下 构建日志不能存在构建中的数据
    var logs = await databaseHelper.listDbByJson({
        p_id,
        env_id,
        success: 3
    }, 'build_log', "*");
    console.log(JSON.stringify(logs));

    if (!_.isEmpty(logs)) {
        throw new Error("存在正在构建的项目！");
    }

    switch (_.lowerCase(typeObj.name)) {
        case "java":
            await javaBuilder.buildJava(projectObj, envObj, typeObj, configList, branch, version);
            break;
        default:
            throw new Error("never used type!");
    }
}


module.exports = {
    build,
}